"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setSwaggerDecorator = void 0;
const constants_1 = require("@nestjs/swagger/dist/constants");
const swagger_1 = require("@nestjs/swagger");
const utils_1 = require("../utils");
const filter_operand_model_1 = require("./filter-operand-model");
const constants_2 = require("../../constants");
const bindings_1 = require("../../config/bindings");
const method_1 = require("./method");
const utils_2 = require("./utils");
function setSwaggerDecorator(controller, entity, config) {
    const apiTag = Reflect.getMetadata(constants_1.DECORATORS.API_TAGS, controller);
    if (!apiTag) {
        const entityName = entity instanceof Function ? entity.name : entity.options.name;
        (0, swagger_1.ApiTags)((0, utils_1.camelToKebab)(entityName))(controller);
    }
    (0, swagger_1.ApiExtraModels)(filter_operand_model_1.FilterOperand)(controller);
    (0, swagger_1.ApiExtraModels)((0, utils_2.createApiModels)(entity))(controller);
    const decoratorOptions = Reflect.getMetadata(constants_2.JSON_API_DECORATOR_OPTIONS, controller);
    for (const method in bindings_1.Bindings) {
        if (decoratorOptions) {
            const { allowMethod = Object.keys(bindings_1.Bindings) } = decoratorOptions;
            if (!allowMethod.includes(method)) {
                continue;
            }
        }
        if (!method_1.swaggerMethod[method]) {
            continue;
        }
        method_1.swaggerMethod[method](controller, entity, bindings_1.Bindings[method], config);
    }
}
exports.setSwaggerDecorator = setSwaggerDecorator;
//# sourceMappingURL=index.js.map