"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseModuleClass = void 0;
const common_1 = require("@nestjs/common");
const constants_1 = require("@nestjs/common/constants");
const helper_1 = require("../../helper");
const __1 = require("../");
const constants_2 = require("../../constants");
const interceptors_1 = require("../interceptors");
const BaseModuleClass = class {
    static forRoot() {
        return {
            module: class {
            },
        };
    }
};
exports.BaseModuleClass = BaseModuleClass;
exports.BaseModuleClass.forRoot = function (options) {
    const { entity, connectionName, controller } = options;
    const entityName = entity instanceof Function ? entity.name : entity.options.name;
    const controllerClass = controller ||
        (0, helper_1.nameIt)((0, helper_1.getProviderName)(entity, constants_2.JSON_API_CONTROLLER_POSTFIX), class {
        });
    const transformService = (0, __1.transformMixin)(entity, connectionName);
    const serviceClass = (0, __1.typeormMixin)(entity, connectionName, transformService);
    (0, common_1.Controller)(`${(0, helper_1.camelToKebab)(entityName)}`)(controllerClass);
    (0, common_1.UseInterceptors)(interceptors_1.ErrorInterceptors)(controllerClass);
    (0, common_1.Inject)(serviceClass)(controllerClass.prototype, 'serviceMixin');
    const properties = Reflect.getMetadata(constants_1.PROPERTY_DEPS_METADATA, controllerClass);
    const serviceToken = (0, helper_1.getProviderName)(controllerClass, constants_2.JSON_API_SERVICE_POSTFIX);
    if (Array.isArray(properties) &&
        properties.find((item) => item.type === serviceToken)) {
        const serviceProp = properties.find((item) => item.type === serviceToken);
        const restProps = properties.filter((item) => item.type !== serviceToken);
        serviceProp.type = serviceClass;
        Reflect.defineMetadata(constants_1.PROPERTY_DEPS_METADATA, [serviceProp, ...restProps], controllerClass);
    }
    const decoratorOptions = Reflect.getMetadata(constants_2.JSON_API_DECORATOR_OPTIONS, controllerClass);
    const moduleConfig = Object.assign(Object.assign(Object.assign({}, constants_2.ConfigParamDefault), options.config), decoratorOptions);
    (0, helper_1.bindController)(controllerClass, entity, connectionName, moduleConfig);
    (0, helper_1.setSwaggerDecorator)(controllerClass, entity, moduleConfig);
    const optionProvider = {
        provide: (0, helper_1.getProviderName)(entity, constants_2.CONFIG_PARAM_POSTFIX),
        useValue: moduleConfig,
    };
    return {
        module: (0, helper_1.nameIt)((0, helper_1.getProviderName)(entity, constants_2.JSON_API_MODULE_POSTFIX), exports.BaseModuleClass),
        controllers: [controllerClass],
        providers: [serviceClass, optionProvider, transformService],
        imports: [],
    };
};
//# sourceMappingURL=module.mixin.js.map